
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import math
import seaborn as sns
sns.set_theme()
save_results_to = '/Users/simen/Desktop/Plot/'
# t = np.arange(0.1,182.4,0.1).tolist()
# VBOX_Speed = ['Longitude']
# CSS_Speed = ['S1_PID_0D_VehicleSpeed']
# data_VBOX = pd.read_csv(r'C:\Users\simen\Desktop\VBOX_062.csv',usecols=VBOX_Speed)
# data_CSS = pd.read_csv(r'C:\Users\simen\Desktop\second time change test export.ChannelGroup_7_OBD2_0x7E8.csv',usecols=CSS_Speed)
#
# data_VBOX = pd.read_csv(r'C:\Users\simen\Desktop\15 mars\VBOX_069.csv',usecols=VBOX_Speed)
# data_CSS = pd.read_csv(r'C:\Users\simen\Desktop\second time change test export.ChannelGroup_7_OBD2_0x7E8.csv',usecols=CSS_Speed)
#
# list_VBOX = data_VBOX['Longitude'].values.tolist()
# list_CSS = data_CSS['S1_PID_0D_VehicleSpeed'].values.tolist()
# print(list_VBOX)
#
# Max = max(list_VBOX + list_CSS)
#
# diff = []
#
def round_half_up(n, decimals=0):
   multiplier = 10 ** decimals
   return math.floor(n*multiplier + 0.5) / multiplier
#
# zip_list = zip(list_VBOX,list_CSS)
# for list_VBOX_i, list_CSS_i in zip_list:
#    diff.append(round_half_up(abs(list_VBOX_i-list_CSS_i), 2))
#
#
# print(Max)
# print(diff)
#
# fig, ax1 = plt.subplots()
#
# color = 'tab:red'
# ax1.set_xlabel('time (s)')
# ax1.set_ylabel('Speed VBOX', color=color)
# ax1.plot(t, data_VBOX, color=color)
# ax1.tick_params(axis='y', labelcolor=color)
#
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
# ax1.set_ylim(0,Max + 5)
# ax2.set_ylim(0,Max + 5)
# color = 'tab:blue'
# ax2.set_ylabel('Speed CSS', color=color)  # we already handled the x-label with ax1
# ax2.plot(t, data_CSS, color=color)
# ax2.tick_params(axis='y', labelcolor=color)
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

# --- Filnavn ---------------------------
# filename = "\Tillerbakken.csv"
# filename = "\Scania_Okstadbakken_100.csv"
filename = "\Vuddudalen_Scania_100.csv"
# filename = "\Hallanbakken_2.csv"
# filename = "\Volvo_Okstadbakken_2.csv"
# filename = "\Sveberg_Scania_100.csv"
# filename = "\Okstadbakken_Mercedes_Arocs_Full.csv"
# filename = "\Moholtbakken_Mercedes_full.csv"
# filename = "\Arocs_Klett_til_Moholt.csv"
# filename = "\Klettbakken_Arocs.csv"
# filename = "\Bakkeprofil_Tiller_2.csv"

BASE_PATH = r"C:\Users\simen\Desktop"
READ_FILE = BASE_PATH + filename

VBOX_Speed = ['Velocity']
data_VBOX = pd.read_csv(READ_FILE,usecols=VBOX_Speed, index_col=False)
speed_VBOX = data_VBOX['Velocity'].values.tolist()

VBOX_distance = ['Distance']
VBOX_height = ['Height']
distance_VBOX = pd.read_csv(READ_FILE, usecols=VBOX_distance, index_col=False)
height_VBOX = pd.read_csv(READ_FILE, usecols=VBOX_height, index_col=False)

# fig, ax1 = plt.subplots()
#
# color = 'tab:red'
# ax1.set_xlabel('Distance [m]')
# ax1.set_ylabel('Height [m]', color=color)
# ax1.plot(distance_VBOX, height_VBOX, color=color)
# ax1.tick_params(axis='y', labelcolor=color)
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

list_distance = distance_VBOX['Distance'].values.tolist()
list_distance = [x-list_distance[0] for x in list_distance]
list_height = height_VBOX['Height'].values.tolist()

# print(list_height)

acchor = 0
deltah = []
deltax = []
stigning = []
Acchor = []
i = 0

for height in range(len(list_height)-1):
    dh = list_height[i+1] - list_height[i]
    deltah.append(dh)
    dx = list_distance[i+1] - list_distance[i]
    deltax.append(dx)
    acchor = dx + acchor
    Acchor.append(acchor)
    if dx == 0:
        s = 0
    else:
        s = dh/dx * 100
    if abs(s) > 15:

        s = 0

    stigning.append(s)
    i = i+1

# Hastighet VBOX -------------------------------
fig, ax1 = plt.subplots()

color = 'tab:red'
ax1.set_xlabel('Horisontal avstand [m]')
ax1.set_ylabel('Hastighet [km/t]', color=color)
ax1.plot(Acchor, speed_VBOX[1:], color=color)
ax1.tick_params(axis='y', labelcolor=color)

fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.show()

# Stigning -------------------------------------
fig, ax1 = plt.subplots()

ax1.set_xlabel('Horisontal avstand [m]')
ax1.set_ylabel('Stigning [%]')
ax1.plot(Acchor, stigning, 'b')
ax1.tick_params(axis='y')
ax1.set_title('VBOX stigning alle loggepunkter')

fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.savefig(save_results_to + 'VBOX_stigning_alle_loggepunkter.pdf')
plt.show()

# Gjennomsnitt stigning 10 -----------------------
stigning10array = np.mean(np.array(stigning).reshape(-1,10), axis=1)
stigning10 = stigning10array.tolist()
Acchor10 = Acchor[9::10]

fig, ax1 = plt.subplots()

ax1.set_xlabel('Distance [m]')
ax1.set_ylabel(' Stigning [%]')
ax1.plot(Acchor10, stigning10, 'b')
ax1.tick_params(axis='y')
fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.savefig(save_results_to + 'Stigning_10_snitt.pdf')
plt.show()

# stigning20array = np.mean(np.array(stigning).reshape(-1,20), axis=1)
# stigning20 = stigning20array.tolist()
# Acchor20 = Acchor[19::20]

# fig, ax1 = plt.subplots()
# ax1.set_xlabel('Distance [m]')
# ax1.set_ylabel('Stigning [%]')
# ax1.plot(Acchor20, stigning20, 'g')
# ax1.tick_params(axis='y')
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.savefig(save_results_to + 'Stigning_20_snitt.pdf')
# plt.show()
#
# stigning100array = np.mean(np.array(stigning).reshape(-1,100), axis=1)
# stigning100 = stigning100array.tolist()
# Acchor100 = Acchor[99::100]
#
# fig, ax1 = plt.subplots()
#
# color = 'tab:blue'
# ax1.set_xlabel('Distance [m]')
# ax1.set_ylabel('Stigning100 dh/dx', color=color)
# ax1.plot(Acchor100, stigning100, color=color)
# ax1.tick_params(axis='y', labelcolor=color)
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

# print(Acchor[math.floor(10.4)])