import pandas as pd
import math
import time
start = time.time()
import matplotlib.pyplot as plt
plt.rcParams.update({'font.size': 12})
import CSV_File_Reader
import IRI_MPD
# import NVDB_posisjon
import numpy as np
from statistics import mean
import seaborn as sns
sns.set_theme()
# sns.set_style('')
import matplotlib.ticker as ticker
save_results_to = '/Users/simen/Desktop/Plot/'
import math

# --- Generering av høydeprofil med NVDB-data ------------------------------------------------
# data = pd.read_csv(r'C:\Users\simen\Desktop\Radata_stigning\Nardobakken3.txt', header=None)
# for i in range(0, len(liste)):
#       for j in range(0, len(liste[i]):
#            x = liste[i][j]
# print(data)
#
# liste = data.values.tolist()
# liste2 = liste[0]
# liste2.reverse() #snur listen i de tilfellene man går mot metrerings\ linjen
#
# #--- Endres til z y x når man går mot metreringslinjen.
# z = liste2[0::3]
# y = liste2[1::3]
# x = liste2[2::3]
#
# Hor = []
# acchor = 0
# ll = []
# ss = []
# c = 0
# c2 = 0
#
# for posisjon in range(len(x) - 1):
#     hor = math.sqrt((x[c + 1] - x[c])** 2 + (y[c + 1] - y[c])**2)
#     Hor.append(hor)
#     acchor = hor + acchor
#     ll.append(acchor)
#     s = (z[c + 1] - z[c]) /hor * 100
#     ss.append(s)
#
#     c = c + 1

# -------------------------------------------------------------------------------
# --- Sveberg ---
# def get_Gir_Sveberg(Gir):
#     if rpm < 800:
#         Gir = Gir - 1
#     # elif rpm < 1250 and Gir == 12 and 800 < x < 1000:
#     #     Gir = Gir - 1
#     elif rpm > 1550 and Gir == 9:
#         Gir = Gir + 1
#     elif rpm > 1450 and Gir == 10:
#         Gir = Gir + 1
#     elif rpm > 1400 and Gir == 11:
#         Gir = Gir + 1
#     return Gir

# --- Vuddu ---

def get_Gir_Vuddu(Gir):
    if rpm < 1032 and d == 0 and x < 1000:
        Gir = Gir - 2
    elif rpm > 1600 and Gir != 12 and d == 0:
        Gir = Gir + 1
    return Gir

# --- Okstad ---
def get_Gir_Okstad(Gir):
    if rpm < 1094 and Gir == 12 and d == 0:
        Gir = Gir - 1
    elif rpm < 1094 and Gir == 11 and d == 0:
        Gir = Gir - 1
    elif rpm < 1015 and Gir == 10 and d == 0:
        Gir = Gir - 1
    elif rpm > 1435 and Gir != 12 and d == 0:
        Gir = Gir + 1
    return Gir

# --- Standard ---
def get_Gir_standard(Gir):
    if rpm < 1000 and d == 0:
        Gir = Gir - 1
    elif rpm > 1400 and Gir != 12 and d == 0:
        Gir = Gir + 1
    return Gir

# --- Sveberg ---
def get_Gir_Sveberg(Gir):
    if Gir == 10 and rpm < 980 and d == 0:
        Gir = Gir -1
    elif Gir != 10 and rpm < 1000 and d == 0:
        Gir = Gir - 1
    elif Gir == 9 and rpm > 1330 and d == 0:
        Gir = Gir + 1
    elif Gir == 10 and rpm > 1200 and x > 600 and d == 0:
        Gir = Gir + 1
    return Gir

# --- Scania ----------------------------------------------

def get_rpm_eff(Gir):
    if Gir == 12:
        rpm_eff = 14.1
    elif Gir == 11:
        rpm_eff = 17.8
    elif Gir == 10:
        rpm_eff = 21.2
    elif Gir == 9:
        rpm_eff = 26.6
    elif Gir == 8:
        rpm_eff = 35.0
    elif Gir == 7:
        rpm_eff = 44
    elif Gir == 6:
        rpm_eff = 53
    elif Gir == 5:
        rpm_eff = 67.5
    elif Gir == 4:
        rpm_eff = 82.5
    return rpm_eff

def get_P_w(rpm):
    if 800 <= rpm < 950:
        P_w = ((rpm - 800) * 0.441 * 1000) + 235.3 * 1000
    elif 950 <= rpm <= 1300:
        P_w = ((rpm - 950) * 0.315 * 1000) + 301.5 * 1000
    elif 1300 < rpm < 1900:
        P_w = ((rpm - 1300) * 0.0245 * 1000) + 411.8 * 1000
    return P_w

# --- Mercedes ------------------------------------------------

# def get_Gir(Gir):
#     if rpm < 1200 and d == 0:
#         Gir = Gir - 1
#     elif rpm > 1600 and Gir != 12 and d == 0:
#         Gir = Gir + 1
#     return Gir
#
# def get_rpm_eff(Gir):
#     if Gir == 12:
#         rpm_eff = 16.3
#     elif Gir == 11:
#         rpm_eff = 21.1
#     elif Gir == 10:
#         rpm_eff = 26.2
#     elif Gir == 9:
#         rpm_eff = 33.95
#     elif Gir == 8:
#         rpm_eff = 43.4
#     return rpm_eff
#
# def get_P_w(rpm):
#     if 800 <= rpm < 1000:
#         P_w = ((rpm - 800) * 0.575 * 1000) + 175 * 1000
#     elif 1000 <= rpm < 1550:
#         P_w = ((rpm - 1000) * 0.245 * 1000) + 290 * 1000
#     elif 1550 <= rpm <= 1800:
#         P_w = 424.75 * 1000
#     return P_w

# --- Volvo ----------------------------------------------------

# def get_Gir(Gir):
#     if rpm < 1000 and d == 0:
#         Gir = Gir - 1
#     elif rpm > 1450 and Gir != 12 and d == 0:
#         Gir = Gir + 1
#     return Gir
#
# def get_rpm_eff(Gir):
#     if Gir == 12:
#         rpm_eff = 15.52
#     elif Gir == 11:
#         rpm_eff = 19.78
#     elif Gir == 10:
#         rpm_eff = 25.31
#     elif Gir == 9:
#         rpm_eff = 32.25
#     elif Gir == 8:
#         rpm_eff = 41.92
#     elif Gir == 7:
#         rpm_eff = 53.40
#     elif Gir == 6:
#         rpm_eff = 67.50
#     elif Gir == 5:
#         rpm_eff = 85.20
#     elif Gir == 4:
#         rpm_eff = 110.15
#     elif Gir == 3:
#         rpm_eff = 140.2
#     elif Gir == 2:
#         rpm_eff = 183
#     elif Gir == 1:
#         rpm_eff = 231
#     return rpm_eff
#
# def get_P_w(rpm):
#     if 600 <= rpm < 1000:
#         P_w = ((rpm - 600) * 0.469 * 1000) + 80.8 * 1000
#     elif 1000 <= rpm <= 1450:
#         P_w = ((rpm - 1000) * 0.286 * 1000) + 268.4 * 1000
#     elif 1450 < rpm < 1900:
#         P_w = 397 * 1000
#     return P_w

# -------------------------------------------------------------------------------

ll = CSV_File_Reader.Acchor10
ss = CSV_File_Reader.stigning10

# ll = NVDB_posisjon.Acchor
# ss = NVDB_posisjon.S

# ll = [400,800,1400,1800,2800]
# ss = [0,3.5,7,3.5,0]

# ll = [2000]
# ss = [0]
speed_VBOX = CSV_File_Reader.speed_VBOX

# ------------------------------------------------------------------------------
# Scania_530 = []
# Scania_580 =
# Scania_

# --- Alternative profiler ------------------------------
# ll = [1000,2000,3000,4000,5000]
# ll = [50,140,356,475,708,908,1023,1489,1763,1906]
#
# --- Klett ---
# ll = [600,245,651,475,255,1326,245,401,350]
# ll = [600,845,1496,1971,2226,3552,3797,4198,4548]
# ss = [0.8,1.7,1.6,1.2,3.6,5.9,3.3,1.7,2.0]
#
# --- Nesdal ---
# ll = [196, 285, 1068, 1279, 1379]
# ss = [2.0, 4.5, 5.5, 3.3, 1.0]
# --- Nesdal mod ---
# ll = [196, 285, 1068, 1279, 1379, 1500, 1700, 2000, 2200, 2700]
# ss = [2.0, 4.5, 5.5, 3.3, 1.0, 0.0, -1.0, -3.0, -1.0, 0.0]
#
# --- Hommelvik ---
# ll = [1969, 2974]
# ss = [3.1, 4.6]
#

# --- Basisparametere ----------
startgir = 11
# --- Vekt ---
m = 50000
# --- Rullemotstand Alt. 1 ---
k_r = 0.001
k_s = 1 / 4470
# --- Rullemotstand Alt. 2 ---
iri = 1.2
mpd = 1.3
# --- Luftmotstand ---
A = 8
cw = 0.6
rho = 1.2
# --- Vindhastighet ---
v0 = 0
# --- Tyngdekraft ---
g = 10
# --- Grenseverdier ---
v_max = 90
a_max = 3.0
# --- Starthastighet ---
v_start = speed_VBOX[0]
# v_start = 60
# --- Startpunkt ---
x1 = 0
h1 = 0
# --- Tidsteg ---
deltaT = 0.01
# --- Effekt gammel modell [kW]---
eff_gammel = 425

# Oppsett = [1,1,1,1,1]
# Oppsett = [0.7,1,1.138,1.326, 1]
Oppsett = [0.96,1,1,1,1]
# --- Lister ---

T = [[] for _ in range(len(Oppsett))]
RPM = [[] for _ in range(len(Oppsett))]
GIR = [[] for _ in range(len(Oppsett))]
X = [[] for _ in range(len(Oppsett))]
H = [[] for _ in range(len(Oppsett))]
V1 = [[] for _ in range(len(Oppsett))]
F_RO = [[] for _ in range(len(Oppsett))]
F_L = [[] for _ in range(len(Oppsett))]
F_CL = [[] for _ in range(len(Oppsett))]
P_W =[[]for _ in range(len(Oppsett))]

for k in range(len(Oppsett)):
    Gir = startgir
    GIR[k].append(startgir)
    t = 0
    stegfaktor = 0.1/deltaT
    v1 = v_start
    stepcounter = 0
    c = 0
    u = 0
    i = 0
    p = 0
    d = 0
    x = x1
    h = h1

    while x < ll[len(ll) - 1]:
        s = ss[c]
        if x > ll[c]:
            c = c + 1
            s = ss[c]

        stepcounter = stepcounter + 1

        v1 = v1 / 3.6

        if u == 10 * stegfaktor:
            u = 0

        if i == 100 * stegfaktor:
            i = 0

        if d == 100 * stegfaktor:
            d = 0

        if i != 0:
            i = i + 1

        if u != 0:
            u = u + 1

        if d != 0:
            d = d + 1
        else:
            rpm = get_rpm_eff(Gir) * v1 * 3.6

        # Gir = get_Gir(Gir)

        if k == 0:
            Gir = get_Gir_Vuddu(Gir)
        else:
            Gir = get_Gir_standard(Gir)

        rpm = get_rpm_eff(Gir) * v1 * 3.6
        P_w = get_P_w(rpm)
        GIR[k].append(Gir)

        if Gir != GIR[k][stepcounter - 1]:
            u = u + 1
            i = i + 1
            d = d + 1

        # --- Girskift tidsbruk ---
        if 0 < u <= 10 * stegfaktor:
            P_w = P_w * 0
        # --- Redusert effekt etter giring ---
        if 10 * stegfaktor < i <= 100 * stegfaktor:
            P_w = P_w * 1

            # if d == 100 * stegfaktor and s < 10:
            #     d = 0

        # --- Varierende iri og mpd ---
        # if IRI_MPD.P[p] < x < IRI_MPD.P[len(IRI_MPD.P)-1]:
        #     p = p + 1
        #
        # if p > 71:
        #     iri = 1.3
        #     mpd = 1.22
        #
        # iri = IRI_MPD.IRI_list[p]
        # mpd = IRI_MPD.MPD_list[p]

        # --- Motstandskrefter ---
        f_r = 0.00414 + 0.0000158 * iri * v1 + 0.00102 * mpd
        # f_r = (k_r + k_s * v1)
        # f_r = 0.015
        F_ro = f_r * m * g * 1
        F_l = 0.5 * rho * A * cw * (v1 + v0) ** 2
        F_cl = m * g * 0.01 * s

        F_RO[k].append(F_ro)
        F_L[k].append(F_l)
        F_CL[k].append(F_cl)

        # if Gir == 10:
        #     P_w = P_w*1

        P_w = P_w*Oppsett[k]

        P_w = P_w*1

        # --- Konstant effekt ---
        if k == 2:
            P_w = eff_gammel * 1000 * 0.839
        if k == 3:
            P_w = eff_gammel * 1000 * 0.95
        if k == 4:
            P_w = eff_gammel * 1000 * 1
        # ---------------------------------

        P_W[k].append(P_w)

        # --- Sum av krefter ---
        F_wn = F_ro + F_l + F_cl
        F_wp = P_w / v1
        F_ws = F_wp - F_wn

        a = F_ws / m

        t = t + deltaT
        deltaX = v1 * deltaT + 0.5 * a * deltaT * deltaT

        x = x + deltaX
        deltaH = (deltaX * s) / 100

        h = h + deltaH
        v1 = v1 + a * deltaT

        T[k].append(t)
        X[k].append(x)
        H[k].append(h)

        RPM[k].append(rpm)

        if v1 >= v_max/3.6:
            v1 = v_max/3.6
            print('Maks hastighet nådd')
        else:
            v1 = v1

        v1 = v1 * 3.6
        V1[k].append(v1)

# --- Printing -----------------------------------------------------------------
        # print(stepcounter)
        # print(iri)
        # print(mpd)
        # print(p)
        # print('U =', u)
        # print(i)
        # print('Gir', Gir)
        # print('kW', P_w / 1000)
        # print('rpm', rpm)
        # print('Luftmotstand', F_l)
        # print('Stigningsmotstand', F_cl)
        # print('Rullemotstand', F_ro)
        # print('Negative krefter sum', F_wn)
        # print('Positive krefter sum', F_wp)
        # print('Sum krefter', F_ws)
        # print('Tid totalt:', t)
        # print('Akselerasjon:', a, 'm/s^2')
        # print('Distanse:', x, 'm')
        # print('Høyde økning:', deltaH, 'm')
        # print('Høyde:', h, 'moh')
        # print('Hastighet:', v1, 'km/t')

# --- Utregning av motstandsgraf ------------------------------------------------

# Motstand_1 = F_CL
# Motstand_2 = [x + y for x, y in zip(F_CL, F_RO)]
# Motstand_3 = [x + y + z for x, y, z in zip(F_CL, F_RO, F_L)]
#
# Sum_motstand = [x + y + z for x, y, z in zip(F_CL, F_RO, F_L)]
# F_CL_DEL = [x/y for x, y in zip(F_CL, Sum_motstand)]
# F_RO_DEl = [x/y for x, y in zip(F_RO, Sum_motstand)]
# F_L_DEL =  [x/y for x, y in zip(F_L, Sum_motstand)]
#
#
#
# Motstand_4 = [x * 100 for x in F_CL_DEL]
# Motstand_5 = [100 * (x + y) for x, y in zip(F_CL_DEL, F_RO_DEl)]
# Motstand_6 = [100* (x + y + z) for x, y, z in zip(F_CL_DEL, F_RO_DEl, F_L_DEL)]

# --- Tilpasse steglengde VBOX- hastighet til beregnede x-koordinater -----------------------

# mod_VBOX = len(speed_VBOX)/len(X[0])
# VS = []
# V1_eq = [[] for _ in range(len(Oppsett))]
#
# for hastighet in range(len(X[0])):
#     vs = speed_VBOX[math.floor(hastighet*mod_VBOX)]
#     VS.append(vs)
#
# for b in range(len(Oppsett)):
#     if len(V1[b]) < len(VS):
#         forhold = len(V1[b])/len(VS)
#         for r in range(len(VS)):
#             speed = V1[b][math.floor(r * forhold)]
#             V1_eq[b].append(speed)
#     else:
#         forhold = len(VS)/len(V1[b])
#         for r in range(len(VS)):
#             speed = V1[b][math.floor(r * forhold)]
#             V1_eq[b].append(speed)

Lengste = max(enumerate(V1), key = lambda tup: len(tup[1]))
Lengste_liste = Lengste[0]

mod_VBOX = len(speed_VBOX)/len(X[Lengste_liste])
VS = []
V1_eq = [[] for _ in range(len(Oppsett))]
X_eq = [[] for _ in range(len(Oppsett))]

for hastighet in range(len(X[Lengste_liste])):
    vs = speed_VBOX[math.floor(hastighet * mod_VBOX)]
    VS.append(vs)

for b in range(len(Oppsett)):
    if len(V1[b]) < len(VS):
        forhold = len(V1[b])/len(VS)
        for r in range(len(VS)):
            speed = V1[b][math.floor(r * forhold)]
            V1_eq[b].append(speed)
            distance = X[b][math.floor(r * forhold)]
            X_eq[b].append(distance)
    else:
        forhold = len(VS)/len(V1[b])
        for r in range(len(VS)):
            speed = V1[b][math.floor(r * forhold)]
            V1_eq[b].append(speed)
            distance = X[b][math.floor(r * forhold)]
            X_eq[b].append(distance)

# --- Plotting --------------------------------------------------------------------
# ---------------------------------------------------------------------------------

#
# fig, ax1 = plt.subplots()
#
# color = 'tab:red'
# ax1.set_xlabel('Horisontal avstand [m]')
# ax1.set_ylabel('Hastighet modell [km/t]', color=color)
# ax1.plot(X, V1[0], color=color)
# ax1.tick_params(axis='y', labelcolor=color)
#
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
# ax1.set_ylim(min(V1[0] + VS) - 1, max(V1[0] + VS) + 1)
# ax2.set_ylim(min(V1[0] + VS) - 1, max(V1[0] + VS) + 1)
# color = 'tab:blue'
# ax2.set_ylabel('Hastighet VBOX [km/t]', color=color)  # we already handled the x-label with ax1
# ax2.plot(X, VS, color=color)
# ax2.tick_params(axis='y', labelcolor=color)
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
#
# plt.grid()
# plt.show()

# fig, ax1 = plt.subplots()
#
# color = 'tab:red'
# ax1.set_xlabel('Horisontal avstand [m]')
# ax1.set_ylabel('Hastighet modell [km/t]', color=color)
# ax1.plot(X, V1, color=color)
# ax1.tick_params(axis='y', labelcolor=color)
#
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
#
# color = 'tab:blue'
# ax2.set_ylabel('Hastighet VBOX', color=color)  # we already handled the x-label with ax1
# ax2.plot(X, VS, color=color)
# ax2.tick_params(axis='y', labelcolor=color)
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

# fig, ax1 = plt.subplots()
#
# color = 'tab:red'
# ax1.set_xlabel('Tid [s]')
# ax1.set_ylabel('Høyde [moh]', color=color)
# ax1.plot(T, H, color=color)
# ax1.tick_params(axis='y', labelcolor=color)
#
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
#
# color = 'tab:blue'
# ax2.set_ylabel('Hastighet', color=color)  # we already handled the x-label with ax1
# ax2.plot(T, V1[0], color=color)
# ax2.tick_params(axis='y', labelcolor=color)
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.grid()
# plt.show()

# fig, ax1 = plt.subplots(figsize=(10,4))
# alpha = 1
# linewidth = 2
# ax1.set_xlabel('Horisontal avstand [m]')
# ax1.set_ylabel('GIR')
# ax1.plot(X[0], GIR[0][:len(X[0])], alpha=alpha, linewidth=linewidth)
# ax1.plot(X[1], GIR[1][:len(X[1])], alpha=alpha, linewidth=linewidth)
# ax1.plot(X[2], GIR[2][:len(X[2])], alpha=alpha, linewidth=linewidth)
# ax1.plot(X[3], GIR[3][:len(X[3])], alpha=alpha, linewidth=linewidth)
# ax1.tick_params(axis='y')
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()
#
# fig, ax1 = plt.subplots(figsize=(10,4))
# alpha = 1
# linewidth = 2
# ax1.set_xlabel('Horisontal avstand [m]')
# ax1.set_ylabel('RPM')
# ax1.plot(X[0], RPM[0], alpha=alpha, linewidth=linewidth)
# ax1.plot(X[1], RPM[1], alpha=alpha, linewidth=linewidth)
# ax1.plot(X[2], RPM[2], alpha=alpha, linewidth=linewidth)
# ax1.plot(X[3], RPM[3], alpha=alpha, linewidth=linewidth)
# ax1.tick_params(axis='y')
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

# --- Girskift og turtall -----------------------------------------------------

fig, ax1 = plt.subplots(figsize=(10,4))
alpha = 1
linewidth = 2
ax1.set_xlabel('Horisontal avstand [m]')
ax1.set_ylabel('GIR')
ax1.plot(X[0], GIR[0][:len(X[0])], alpha=alpha, linewidth=linewidth)
ax1.tick_params(axis='y')

fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.show()

fig, ax1 = plt.subplots(figsize=(10,4))
alpha = 1
linewidth = 2
ax1.set_xlabel('Horisontal avstand [m]')
ax1.set_ylabel('RPM')
ax1.plot(X[0], RPM[0], alpha=alpha, linewidth=linewidth)
ax1.tick_params(axis='y')

fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.show()

# --- Forskjellig motoreffekt ------------------------------------------------

# fig, ax1 = plt.subplots()
#
# color = 'tab:pink'
# ax1.set_xlabel('Tid [s]')
# ax1.set_ylabel('Høyde [moh]', color=color)
# ax1.plot(T, H, color=color)
# ax1.tick_params(axis='y', labelcolor=color)
#
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
#
# color = 'tab:blue'
# ax2.set_ylabel('RPM', color=color)  # we already handled the x-label with ax1
# ax2.plot(T, RPM, color=color)
# ax2.tick_params(axis='y', labelcolor=color)
#
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

# Hastighet, Stigning mot Avstand

# fig, ax1 = plt.subplots(figsize=(10,10))
# ax1.set_xlabel('Horisontal avstand [m]')
# ax1.set_ylabel('Hastighet [km/t]')  # we already handled the x-label with ax1
# ax1.plot(X[0], V1[0], label='530')
# ax1.plot(X[1], V1[1], label='580')
# ax1.plot(X[2], V1[2], label='660')
# ax1.plot(X[3], V1[3], label='770')
# ax1.plot(X[4], V1[4], label='580 gammel')
# ax1.plot(X[4], VS, label='VBOX')
#
# ax1.set_ylim([27.5, 95])
# ax1.minorticks_on()
# ax1.tick_params(axis='y')
# plt.legend(loc=6, prop={'size': 10})
# # ax1.set_facecolor('#bfbfbf')
#
# color = 'blue'
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
#
# ax2.set_ylabel('Høyde [m]', color=color)
# ax2.plot(X[0], H[0], color =color)
# ax2.tick_params(axis='y', colors=color)
# ax2.set_ylim([-5, 130])
# ax2.minorticks_on()
# ax2.grid(False)

# plt.savefig(save_results_to + 'Hastighet_ulik_effekt.pdf', bbox_inches='tight')
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

# --- Sammenligning av ny og gammel graf -----------------------------

fig, ax1 = plt.subplots(figsize=(10,5))
ax1.set_xlabel('Horisontal avstand [m]')
ax1.set_ylabel('Hastighet [km/t]')  # we already handled the x-label with ax1

# plt.axvline(220, color='grey')
# plt.axvline(680, color='grey')
# plt.axvline(1120, color='grey')
# plt.axvline(2130, color='grey')
#
# plt.axvline(390, color='c')
# plt.axvline(810, color='c')
# plt.axvline(1190, color='c')
# plt.axvline(1550, color='c')
# plt.axvline(2120, color='c')
#
# plt.text(220, 86, '12 > 11', bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2}, ha='left', va='bottom', rotation=45, size=9)
# plt.text(680, 86, '11 > 10', bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2}, ha='left', va='bottom', rotation=45, size=9)
# plt.text(1100, 86, '10 > 9', bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2}, ha='left', va='bottom', rotation=45, size=9)
# plt.text(2150, 86, '10 > 11', bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2}, ha='left', va='bottom', rotation=45, size=9)
#
# plt.text(390, 86, '12 > 11', bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2}, ha='left', va='bottom', rotation=45, size=9)
# plt.text(810, 86, '11 > 10', bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2}, ha='left', va='bottom', rotation=45, size=9)
# plt.text(1190, 86, '10 > 9', bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2}, ha='left', va='bottom', rotation=45, size=9)
# plt.text(1550, 86, '9 > 10', bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2}, ha='left', va='bottom', rotation=45, size=9)
# plt.text(2050, 86, '9 > 10', bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2}, ha='left', va='bottom', rotation=45, size=9)

# Forhold = len(V1[4])/len(V1[3])
# V3MOD = []
#
# for hastighet in range(len(V1[4])):
#     v3mod = V1[3][math.floor(hastighet*Forhold)]
#     V3MOD.append(v3mod)

ax1.plot(X_eq[0], VS, label='VBOX', color='g')
ax1.plot(X_eq[1], V1_eq[1], label='R580 standard giring', color='r')
ax1.plot(X_eq[0], V1_eq[0], label='R580 tilpasset giring', color='orange', linewidth=2)
# ax1.plot(X[2], V1[2], label='R580 gammel modell justert', color='orange', linewidth=2)

ax1.plot(X_eq[3], V1_eq[3], '--', label='R580 gammel modell 95 %', color='c')
# ax1.plot(X[4], V1[4], '--', label='R580 gammel modell 85 %', color='orange')
# ax1.plot(X[4], V3MOD, '--', label='R580 gammel modell 80 %', color='orange')




# plt.legend(loc=9, prop={'size': 10})

# ax1.fill_between(X[4], V3MOD, V1[4], facecolor='orange', alpha=0.15, interpolate=True)

ax1.set_ylim([27.5, 85])
ax1.tick_params(axis='y')
plt.xticks(np.arange(0, max(X[0]) + 100, 200))
# plt.legend(loc=9, prop={'size': 10})

# plt.axvline(290, color='c')
#
# plt.text(290, 86, '11 > 9', bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2}, ha='left', va='bottom', rotation=45, size=9)

# color = 'blue'
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis

# ax2.set_ylabel('Vertikal avstand [m]', color=color)
# ax2.plot(X[0], H[0], color =color)
# ax2.tick_params(axis='y', colors=color)
# ax2.set_ylim([-5, 130])
# ax2.grid(False)

plt.savefig(save_results_to + 'Plott_forside.png', bbox_inches='tight')
fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.show()

# --- Forskjellig motoreffekt ------------------------------------------------

# fig, ax1 = plt.subplots(figsize=(10,4))
# ax1.set_xlabel('Horisontal avstand [m]')
# ax1.set_ylabel('Hastighet [km/t]')  # we already handled the x-label with ax1
# ax1.plot(X[0], V1[0], label='Volvo 540')
# ax1.plot(X[0], VS, label='VBOX')
#
# ax1.set_ylim([27.5, 95])
# ax1.minorticks_on()
# ax1.tick_params(axis='y')
# plt.legend(loc=6, prop={'size': 10})
# # ax1.set_facecolor('#bfbfbf')
#
# color = 'blue'
# ax2 = ax1.twinx()  # instantiate a second axes that shares the same x-axis
#
# ax2.set_ylabel('Høyde [m]', color=color)
# ax2.plot(X[0], H[0], color =color)
# ax2.tick_params(axis='y', colors=color)
# ax2.set_ylim([-5, 130])
# ax2.minorticks_on()
# ax2.grid(False)
#
# plt.savefig(save_results_to + 'Hastighet_ulik_effekt.pdf', bbox_inches='tight')
# fig.tight_layout()  # otherwise the right y-label is slightly clipped
# plt.show()

# --- Absolutt motstandsgraf ---------------------------------------------------

# fig, ax = plt.subplots()
#
# ax.plot(X, Motstand_1, X, Motstand_2, X, Motstand_3, color='black', linewidth=0.5)
# ax.set_xlabel('Horisontal avstand [m]')
# ax.fill_between(X, 0, Motstand_1, facecolor='#24a65e', interpolate=True)
# ax.fill_between(X, Motstand_1, Motstand_2, facecolor='#246ba6', interpolate=True)
# ax.fill_between(X, Motstand_2, Motstand_3, facecolor='#24a6a0', interpolate=True)
# ax.set_title('Motstandskrefter')
#
# plt.savefig(save_results_to + 'Motstandskrefter.pdf', bbox_inches='tight')
# ax.grid(axis='y')
# plt.show()
#
# fig10, ax = plt.subplots()
#
# ax.plot(X, F_CL_DEL, X, F_RO_DEl, X, F_L_DEL, color='black')
# ax.fill_between(X, 0, F_CL_DEL, facecolor='#24a65e', interpolate=True)
# ax.fill_between(X, F_CL_DEL, F_RO_DEl, facecolor='#246ba6', interpolate=True)
# ax.fill_between(X, F_RO_DEl, F_L_DEL, facecolor='#24a6a0', interpolate=True)
# ax.set_title('fill between where')

# plt.show()

# --- Motstandsgraf -----------------------------------------------------
# --- Laget uten seaborn -----

# fig, ax = plt.subplots()
#
#
# twin1 = ax.twinx()
# twin2 = ax.twinx()
#
# fig.subplots_adjust(right=0.75)
#
# twin2.spines["right"].set_position(("axes", 1.2))
# # twin2.spines.right.set_position(("axes", 1.2))
#
# ax.set_xlim(0, X[len(X)-1])
# ax.set_ylim(0, 100)
# twin1.set_ylim(min(V1[0])-5, max(V1[0])+5)
# twin2.set_ylim(min(H)-5, max(H)+5)
#
# ax.plot(X, Motstand_4, color='black', linewidth=0.5)
# ax.plot(X, Motstand_5, color='black', linewidth=0.5)
# ax.plot(X, Motstand_6, color='black', linewidth=0.5)
# # ax.plot(X, Motstand_5, color='black', linewidth=0.5)
# # ax.plot(X, Motstand_6, color='black', linewidth=0.5)
# twin1.plot(X, V1[0], color="red")
# twin2.plot(X, H, color= "blue")
#
# ax.set_xlabel("Horisontal avstand [m]")
# ax.set_ylabel("Andel av total kjøremotstand [%]")
# twin1.set_ylabel("Hastighet [km/t]", color="red")
# twin2.set_ylabel("Høyde [m]", color="blue")
#
# ax.fill_between(X, 0, Motstand_4, facecolor='#24a65e', alpha=0.5, interpolate=True)
# ax.fill_between(X, Motstand_4, Motstand_5, facecolor='#246ba6', alpha=0.5, interpolate=True)
# ax.fill_between(X, Motstand_5, Motstand_6, facecolor='#24a6a0', alpha=0.5, interpolate=True)
# # ax.set_title('Motstandskrefter andeler')
#
# # Set axes colors
# ax.spines["left"].set_color("black")
# twin1.spines["right"].set_color("black")
# twin2.spines["right"].set_color("black")
#
# ax.minorticks_on()
# twin1.minorticks_on()
# twin2.minorticks_on()
# # y_ticks = np.arange(0, 1.0001, 0.1)
# # plt.yticks(y_ticks)
#
# ax.tick_params(direction="in", which="both", colors="black")
# twin1.tick_params(direction="in", which="both", colors="red")
# twin2.tick_params(direction="in", which="both", colors="blue")
#
# ax.set_title('Motstandskrefter, 111 kg/kW', fontsize = 12)
#
# # plt.text(1450, 34, '(a)')
# # plt.text(2250, 20, '(b)')
# # plt.text(2500, 62, '(c)')
# # plt.text(100, 1, '0,0%')
# # plt.text(445, 12, '3,5%')
# # plt.text(980, 48, '7,0%')
# # plt.text(1365, 65, '3,5%')
# # plt.text(2100, 71, '0,0%')
#
# plt.savefig(save_results_to + 'Motstandskrefter_andeler_2.pdf', bbox_inches='tight')
# # ax.grid(axis='y')
# plt.show()
# ------------------------------------------------------------------------------------
# fig,ax1=plt.subplots(figsize=(10,5))
# ax1.set_xlabel('Horisontalavstand[m]')
# ax1.set_ylabel('Hastighet[km/t]')#wealreadyhandledthex-labelwithax1
#
# plt.axvline(220,color='grey')
# plt.axvline(680,color='grey')
# plt.axvline(1120,color='grey')
# plt.axvline(1740,color='grey')
# plt.axvline(2130,color='grey')
# plt.axvline(2300,color='grey')
#
# plt.axvline(390,color='c')
# plt.axvline(810,color='c')
# plt.axvline(1190,color='c')
# plt.axvline(1550,color='c')
# plt.axvline(2120,color='c')
#
# plt.text(220,86,'12>11',bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(680,86,'11>10',bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(1100,86,'10>9',bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(1740,86,'9>10>9',bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(2150,86,'9>10',bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(2300,86,'10>11',bbox={'facecolor':'white','alpha':1,'edgecolor':'grey','pad':2},ha='left',va='bottom',rotation=45,size=9)
#
#
# plt.text(390,86,'12>11',bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(810,86,'11>10',bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(1190,86,'10>9',bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(1550,86,'9>10',bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2},ha='left',va='bottom',rotation=45,size=9)
# plt.text(2050,86,'10>11',bbox={'facecolor':'white','alpha':1,'edgecolor':'c','pad':2},ha='left',va='bottom',rotation=45,size=9)
#
#
# ax1.plot(X[0],V1[0],label='FH 540 ny modell',color='r')
# ax1.plot(X[1],V1[1],'--',label='FH 540 gammel modell',color='orange')
# ax1.plot(X[1],VS,label='VBOX',color='g')
# plt.legend(loc=9,prop={'size':10})
#
# ax1.set_ylim([27.5,85])
# ax1.tick_params(axis='y')
# plt.xticks(np.arange(0,max(X[0])+100,200))
# plt.legend(loc=9,prop={'size':10})
#
# color='blue'
# ax2=ax1.twinx()#instantiateasecondaxesthatsharesthesamex-axis
#
# ax2.set_ylabel('Vertikalavstand[m]',color=color)
# ax2.plot(X[0],H[0],color=color)
# ax2.tick_params(axis='y',colors=color)
# ax2.set_ylim([-5,110])
# ax2.grid(False)
#
# plt.savefig(save_results_to+'Hastighet_ny_og_gammel_volvo_Okstadbakken.pdf',bbox_inches='tight')
# fig.tight_layout()#otherwisetherighty-labelisslightlyclipped
# plt.show()

# -----Diverse print konsoll------------------------

end = time.time()
print('Tid:', round(T[0][len(T[0])-1],2), 'v_slutt:', round(V1[0][len(V1[0])-1],1), 'v_max:', round(max(V1[0]), 1), 'v_min:', round(min(V1[0]), 1))
print('Tid:', round(T[1][len(T[1])-1],2), 'v_slutt:', round(V1[1][len(V1[1])-1],1), 'v_max:', round(max(V1[1]), 1), 'v_min:', round(min(V1[1]), 1))
# print('Tid:', round(T[2][len(T[2])-1],2), 'v_slutt:', round(V1[2][len(V1[2])-1],1), 'v_max:', round(max(V1[2]), 1), 'v_min:', round(min(V1[2]), 1))
# print('Tid:', round(T[3][len(T[3])-1],2), 'v_slutt:', round(V1[3][len(V1[3])-1],1), 'v_max:', round(max(V1[3]), 1), 'v_min:', round(min(V1[3]), 1))
# print('Tid:', round(T[4][len(T[4])-1],2), 'v_slutt:', round(V1[4][len(V1[4])-1],1), 'v_max:', round(max(V1[4]), 1), 'v_min:', round(min(V1[4]), 1))

average = mean(ss)
average_pw1 = mean(P_W[1])
average_pw2 = mean(P_W[2])
print("Gjennomsnittlig stigning =", round(average, 2), "%")
print("Gjennomsnittlig effekt ny modell", round(average_pw1/1000,2))
print("Gjennomsnittlig effekt gammel modell", round(average_pw2/1000,2))
print("Ny modell prosent av gammel snitt", round(average_pw1/10/425,3), "%")

GEH_list = [[] for _ in range(len(Oppsett))]
GEH_snitt = []
for w in range(len(Oppsett)):
    for q in range(len(V1_eq[w])):
        GEH = (math.sqrt(2 * (V1_eq[w][q] - VS[q]) ** 2) / (V1_eq[w][q] + VS[q]))
        GEH_list[w].append(GEH)
    geh_snitt = sum(GEH_list[w])/len(GEH_list[w])
    GEH_snitt.append(geh_snitt)
    print('GEH_snitt', w, '=', GEH_snitt[w])

# --- Tid koden bruker på å kjøre -----------------------------
print(end-start)
