import pandas as pd
import math
import matplotlib.pyplot as plt

data = pd.read_csv(r'C:\Users\simen\Desktop\Radata_stigning\Tillerbakken_sammenligning.txt', header=None)

liste = data.values.tolist()
liste2 = liste[0]
liste2.reverse() #snur listen i de tilfellene man går mot metreringslinjen

#--- Endres til z y x når man går mot metreringslinjen ---
z = liste2[0::3]
y = liste2[1::3]
x = liste2[2::3]

Hor = []
acchor = 0
Acchor = []
S = []
c = 0
c2 = 0

for posisjon in range(len(x) - 1):
    hor = math.sqrt((x[c + 1] - x[c])** 2 + (y[c + 1] - y[c])**2)
    Hor.append(hor)
    acchor = hor + acchor
    Acchor.append(acchor)
    s = (z[c + 1] - z[c]) /hor * 100
    S.append(s)

    c = c + 1
    # print(c)
    # print(x[c])
    # print(y[c])

Q = [0,]
L = Q + Acchor

fig, ax1 = plt.subplots()

color = 'tab:green'
ax1.set_xlabel('Horisontal avstand [m]')
ax1.set_ylabel('Høyde [m]', color=color)
ax1.plot(L, z, color=color)
ax1.tick_params(axis='y', labelcolor=color)

fig.tight_layout()  # otherwise the right y-label is slightly clipped
plt.show()


fig, ax1 = plt.subplots()

color = 'tab:red'
ax1.set_xlabel('Horisontal avstand [m]')
ax1.set_ylabel('Stigning NVDB [%]')
ax1.plot(Acchor, S, 'r')
ax1.tick_params(axis='y')

fig.tight_layout()  # otherwise the right y-label is slightly clipped

plt.show()